ChangeLog
---------
Version 4.2.0:
released as version 4.2.0

Version 4.2-snapshot-20080802:
- bug fixes

Version 4.2-snapshot-20080726:
- bug fixes
- reorganized the configuration dialog to use a QScrollArea and combined
  some (split) settings onto a big scrolling page
- extended the templates system to support a few predefined variables
  (thanks to Dan Bullok)

Version 4.2-snapshot-20080719:
- bug fixes
- updated Turkish translations from Serdar Koçdaş
- updated Spanish translations from Jaime Seuma
- updated Czech translations from Zdenek Böhm
- added API file for Ruby
- added Ruby API file for eric4 Ruby files
- enhanced the API file generation tool and dialog
- updated the plugin document

Version 4.2-snapshot-20080706:
- bug fixes
- changed subversion relocate function to perform a relocation inside
  a repository
- added an indication of the current editor's language to the status bar
- moved all supporting project management files (e.g. tasks file) to a
  management subdirectory
- changed the autocompletion and calltips hook support
  Note: the latest rope plugin snapshot is required
- updated Turkish translations from Serdar Koçdaş
- updated Spanish translations from Jaime Seuma

Version 4.2-snapshot-20080628:
- bug fixes
- updated French translations from Julien Vienne
- updated Spanish translations from Jaime Seuma
- added Turkish translations from Serdar Koçdaş
- added a double click action and a reload button to the shell history dialog
- made improvements to the Plugin Info dialog
- added capability to save the folding state of a file in the session file
- added capability to save the open multi project and the open project in
  the global session file
- added a Ctrl-Click action to the editor to show the info related to a
  syntax error
- added an action to send a feature request using the email dialog
- separated QScintilla specific autocompletion and calltips configuration
  from general configuration
- moved configuration of the VCS indicator colours to the VCS configuration page
- added the --noopen commandline parameter to override the OpenOnStartup 
  configuration setting (mostly used for eric4 development)

Version 4.2-snapshot-20080615:
- bug fixes
- compatibility fix for Ubuntu and Mandriva
- added the relocate action to the vcsSubversion plugin
- added an action to insert a new line below the current one (Shift+Return)
- added a QWebKit based help viewer (available if Qt 4.4 is installed)
- made some network related aspects configurable
- added storage key PROJECTTYPESPECIFICDATA for project type specific
  data (may be used by project type plugins)
- made Shell history more comfortable by
  -- selecting from history via a dialog
  -- list the history in a dialog with capabilities to
     --- delete entries
     --- copy entries to the current editor
     --- execute entries in the shell
- made the size grip of the main window configurable (s. Interface (Part 1))

Version 4.2-snapshot-20080525:
- bug fixes
- added print preview capability (available if Qt 4.4 is installed)
- added new default icon set based on the Oxygen icons
- added some more icons

Version 4.2-snapshot-20080519:
- bug fixes
- compatibility fix for Qt 4.4

Version 4.2-snapshot-20080503:
- bug fixes
- added capability to the API generator to extract global variables
  and class variables
- added double click action to the tabview viewmanager. Double clicking
  the space right of the last tab opens a new editor.
- added indicator for the current editors encoding to the status bar
- changed compare and side-by-side compare dialogs to have the filename
  of the current editor as the first file
- added hook support for plugins providing calltips

Version 4.2-snapshot-20080406:
- bug fixes
- added double click support for attributes and globals
- reorganized the configuration dialog some more
- added various startup configuration options (application page)
- added functionality to mark all occurrances of a searched text
  (s.a. configuration dialog editor->searching page)
- enhanced unicode support (added utf-16 and utf-32)
- a few changes to the PyKDE4 support code to work around a PyKDE4
  problem with the Oxygen style (this workaround allows eric4 to
  use the Oxygen style, when KDE4 dialogs are disabled)
- added hook support for plugins providing autocompletion
- added action and menu entries to show calltips

Version 4.2-snapshot-20080319:
- bug fixes
- added support for the coding line to the Python and Ruby class browsers
- added support for module global variables and class (global) variables

Version 4.2-snapshot-20080318:
- bug fixes
- added an LED to signal the project's VCS status to the project viewer
- reorganized the configuration dialog
- added a button to configure the eol fill setting for all styles of a lexer
- added capability to save UML like graphics as SVG
- added capability to display SVG files
- made some improvements to the code metrics dialog
- enhanced the printing support
- added lexer support for TCL/Tk files
- added the PyKDE4 compatibility code
- added project support for KDE 4 projects

Version 4.2-snapshot-20080302:
- bug fixes
- added hook support to ProjectFormsBrowser, ProjectResourcesBrowser and
  ProjectTranslationsBrowser
- added support to provide API files by plugins
- moved Django support to an external plugin
- moved TurboGears support to an external plugin
- moved wxPython support to an external plugin

Version 4.2-snapshot-20080224:
- bug fixes
- changed settings from native format to ini format
- made number of recently opened projects and files configurable
- added multiproject support
- changed formats of some XML files
- extended the workspace view manager
- added a viewmanager using the new QMdiArea
- added HTTPS support to plugin repository dialog (for Qt 4.3 and newer)
- added actions to the graphics views to align the shapes

Version 4.2-snapshot-20080210:
- bug fixes
- added configuration option to select the text shown in the
  tabview viewmanager tabs
- changed project browsers to override the default double click
  action
- added a toolbar manager and a toolbar configuration dialog
- cleaned up the default toolbars
- changed watchpoint to watch expression to make it's use clearer
- added additional move actions to TabWidget
- cleaned up the API of E4Action and replace E4ActionGroup by 
  the createActionGroup module function

Version 4.1.0:
released as version 4.1.0
- added API files for wxPython
- added API files for Zope 2 and Zope 3

Version 4.1-snapshot-20080118:
- bug fixes
- added and changed a few methods of the VCS interface modules, which 
  were needed by the rope refactoring plugin
- added some methods needed for the rope plugin

Version 4.1-snapshot-20080107:
- bug fixes
- changed the plugin repository dialog to download multiple files
- added a button to the plugin repository dialog to close it and
  open the plugin installation dialog
- changed the plugin repository dialog to indicate, if a plugin
  needs a fresh download
- changed the plugin repository dialog to indicate the 
  status of a plugin as given in the repository file
- added Spanish translations from Daniel Malisani (still incomplete)
- added API files for Django and TurboGears

Version 4.1-snapshot-20071224:
- bug fixes
- made number of Subversion commit messages to remember configurable
- added buttons to edit the Subversion config and servers file to the
  Subversion configuration page
- changed the plugin installation dialog to be able to 
  install multiple plugin archives
- added menu entry and code to create a snapshot plugin archive
- added a simplified editor dialog and an associated main script
- created a main script to start the plugin repository dialog

Version 4.1-snapshot-20071216:
- bug fixes
- added a Repository Browser to the PySvn VCS plugin
- added a Repository Browser to the Subversion VCS plugin
- added a Log Browser to the PySvn VCS plugin
- added a Log Browser to the Subversion VCS plugin
- made the visible project browsers configurable
- added project type for wxPython
- added functionality to strip trailing whitespace upon saving to the editor
- removed the scripting stuff because the plugin system is much more capable
- added a stop function to the find in files dialog
- added a search text entry to the keyboard shortcuts dialog

Version 4.1-snapshot-20071118:
- bug fixes
- added version info to the plugin repository dialog
- refactored PyLint plugin as a separate plugin distribution package
- refactored CVS plugin as a separate plugin distribution package

Version 4.1-snapshot-20071111:
- bug fixes
- added an action to stop the running script to the "Start" menu/toolbar
- added a config option for the plugins download directory
- added dialog to display the plugin repository and download plugins
- refactored CxFreeze plugin as a separate plugin distribution package

Version 4.1-snapshot-20071021:
- bug fixes
- added a dialog to show the eric4 versions available for download
- added the project types "Django" and "TurboGears"
- added a button to the Start ... dialog to clear the history lists
- added a configuration option (Project page) to enable a recursive search
  for new files
- added configuration option (Plugin Manager page) to disable loading
  of 3rd party plugins
- added code to the imports diagram to cope with relative imports as of
  Python 2.5 and to show external imports
- added code to the application diagram to cope with relative imports as of
  Python 2.5 

Version 4.1-snapshot-20070924:
- bug fixes
- added the menu entry "New package..." to the project sources browser 
  context menus
- removed configuration option to specify the directory of the Qt4 installation
  (it is now required, that the Qt bin directory is in the PATH)
- changed code of Python debug client to better intercept output
- added a source code exporter to write the colourised source as HTML, PDF, 
  RTF and LaTeX

Version 4.1-snapshot-20070813:
- bug fixes
- compatibility fixes for Debian
- added 'load', 'save' and 'next match' actions to the regexp wizards
- made the VCS clients update their status after a commit, update and revert
- added '-z' to the installer to inhibit compilation of the python files
- added documentation of the new plugin system

Version 4.1-snapshot-20070721:
- bug fixes
- changed VCS interfaces to plugins
- changed wizards to plugins
- added methods to register/unregister a toolbar with the UserInterface.
  This must be used by plugins, which create their own toolbar.
- added code to allow a plugin to clean up before it gets uninstalled

Version 4.1-snapshot-20070708:
- bug fixes
- made plugins deactivateable and added a context menu to the plugins
  info dialog
- added code to remember the deactivated plugins
- added dialog to install new plugins
- added dialog to uninstall plugins
- added the methods registerPluginObject/unregisterPluginObject to 
  KQApplication to allow Plugins to register their object.
- added code to allow registered plugins, that have a getActions() method
  to have the shortcuts configured via the shortcuts configuration dialog
- added code to allow active plugins to be configured via the
  configuration dialog
- added the commandline option --plugin=pluginfile to eric4.py. This
  option can be used for plugin development to specify a plugin file
  to load (e.g. eric4 --plugin=/my/plugin/develoment/area/PluginTest.py).
- added actions and code to create eric4 plugin archive files
- added the new project type "Eric4 Plugin"
- added code to run/debug/... an eric4 plugin from within eric4 by starting
  another eric4 process instead of the plugin main script
- removed the character tables dialog
  (will be provided as a plugin by Jürgen Urner)
- removed the Bicycle Repair Man code and converted it to a standalone
  plugin
- added option to configure, whether the project browsers should highlight
  the entry for the file of the current editor
- added a field to enter a more descriptive text for a task
- changed the way how files and directories can be added to a project in
  order to respect the project's filetype associations

Version 4.1-snapshot-20070622:
- bug fixes
- implemented a (basic) plugin system to allow people to extend eric4
- converted view managers to plugins
- converted the About functionality to a plugin
- converted the checkers to plugins
- converted the packagers to plugins
- converted the documentation tools to plugins

Version 4.0.0:
- first official release

Version 4.0-snapshot-20070526:
- bug fixes
- made improvements to the typing completers
- added more rules to the Ruby typing completer

Version 4.0-snapshot-20070517:
- bug fixes
- added code for the final QScintilla2 calltips API
- added a check to see, if eric4 has been configured. If not, the
  configuration dialog is started automatically.
- added Python typing rules for try-except-finally blocks
- updated PyLint support for 0.13.0
- moved VCS status monitor LED code from UserInterface to it's own class
  and gave it a context menu
- added the '-p' switch to eric4-api to include private classes, methods
  and functions in the resulting API file

Version 4.0-snapshot-20070506:
- bug fixes

Version 4.0-snapshot-20070505:
- bug fixes
- added CMake lexer support
- added VHDL lexer support
- made the help viewer keyboard shortcuts configurable
- added support for the case insensitive variant of the C++ lexer
- added some code to perform automatic insertions while typing (Ruby)
- added config options for entering a prefix and/or a postfix for
  Qt tools (e.g. on Kubuntu it is "-qt4" to make "designer-qt4")

Version 4.0-snapshot-20070411:
- bug fixes
- added Czech translations (thanks to Zdenek Böhm)
- added some code to perform automatic insertions while typing (Python)
- more win32 compatibility issues fixed

Version 4.0-snapshot-20070402:
- bug fixes
- changed the shortcuts dialog to show icons of the actions
- moved the dialog showing external tools used by eric4 to the
  preferences menu
- changed the handling of the commit message dialogs to enhance
  their usability.
- added a dialog to derive code for a forms implementation for Qt4
- enhanced win32 comptibility

Version 4.0-snapshot-20070325:
- bug fixes
- updated to chartables 0.5.2
- extended the svn diff capabilities
- extended the eric4-api and eric4-doc tools
- added @see, @since and {@link} to eric4-doc
- changed structure of debug server
- extended the subversion status dialogs by an add and revert action
- added a "Recreate project tasks" action to the taskviewer context menu
- added D lexer support
- added Povray lexer support
- added file and directory completers to various dialogs
- added a top level exception handler to log the exception info

Version 4.0-snapshot-20070218:
- bug fixes
- changed graphics to use QGraphicsView
- changed Pylint support for pylint >= 0.12.0
- changed the compare dialog to be more specific about changed lines
- changed install script to patch pyXML in order to fix a bug there

Version 4.0-snapshot-20070204:
- bug fixes
- added check for syntax errors when a project run/debug/... action
  is invoked. The number of faulty files will be displayed and the
  action aborted.
- added an option to hide generated source of forms files (those
  starting with Ui_)
- added an entry "Find in this directory" to the browser context
  menu
- extended the compare dialog by movement buttons
- changed the debugger to accept environment settings of the form
  'var+=value' in order to ammend an existing environment variable
- added support for svn diff against HEAD and COMMITTED
- added esc handlers to the email and template dialogs
- changed dialogs to use QDialogButtonBox

Version 4.0-snapshot-20070114:
- bug fixes
- added configuration option to enable/disable the usage of
  autocompletion fill-up characters
- added support for the new QScintilla2 APIs interface

Version 4.0-snapshot-20061230:
- bug fixes
- added configuration option to select the font used for the graphics
  displays
- changed the logic of the editor search and replace dialogs
- added even more compatibility changes for Subversion 1.4.0
- backed out the Qt4 workaround for Linux because it was causing trouble

Version 4.0-snapshot-20061222:
- bug fixes
- reworked the Edit menu to make it a bit shorter
- added capability to add existing translation files
- added a close button to the tab view, which closes the current editor
- added capability to save the help window size and position (and a
  configuration option to enable this)
- added close tab and new tab buttons to the help viewer window
- added more compatibility changes for Subversion 1.4.0

Version 4.0-snapshot-20061217:
- bug fixes
- added capability to exclude files and directories from translation
- updated to chartables v. 0.5.0
- added actions to go to the next/previous task of an open editor
- added a dialog to override some global settings on a per project basis
- added the capability to resize the configuration dialog's contents via
  a splitter
- added tabbed browsing to the help viewer
- added configuration option to use just one help browser window
- rearranged editor context menu and introduced an option to show a
  minimalistic context menu (for small screens)
- extended help texts for the Python and Qt regexp wizard dialogs

Version 4.0-snapshot-20061112:
- bug fixes
- more Qt 4.2.0 changes
- added the character tables dialog from Jürgen Urner
- added support for Qt style sheets
- added an apply and reset action to the configuration dialog

Version 4.0-snapshot-20061029:
- bug fixes
- added a configuration option for the default font of the editor
- changed layout of the editors search and replace dialogs
- added an eric4 tray starter application. It adds an icon to the
  systemtray, which gives a context menu to start eric4 with
  recently opened projects or files and to start the various
  tools included in eric4

Version 4.0-snapshot-20061022:
- bug fixes
- adaptation to Qt 4.2.0 (Qt 4.2.0is a prerequisite)
- completed Russian translation (thanks to Alexander Darovsky)

Version 4.0-snapshot-20061014:
- bug fixes
- some Qt 4.2.0 compatibility fixes
- added capability to reset the window layout via eric4-configure

Version 4.0-snapshot-20061009:
- many bug fixes
- added a QFileIconProvider derived class to show more specific
  icons in the file dialog.
- made code changes for latest QScintilla2 snapshot

Version 4.0-snapshot-20061002:
- many bug fixes
- added capability to set several lexer styles (font and colours)
  simultaneously
- added capability to clear the interpreter window on activation
  of a run, debug, ... action
- added capability to not stop the debugger on the first executable
  line
- all selections made in the run, debug, ... start dialog are saved
  across invocations of eric4
- added capability to restrict the network interfaces, the debug server
  listens on, and the hosts allowed to connect to the debug server

Version 4.0-snapshot-20060923:
- many bug fixes
- added compatibility with Subversion 1.4.0
- added option to select the UI style (Preferences->Interface->Style)

Version 4.0-snapshot-20060913:
- first public snapshot of eric4
